package ir.cristiansoft.spammer;

import android.app.Dialog;
import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.support.annotation.NonNull;
import android.support.design.widget.NavigationView;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class MainActivity extends AppCompatActivity {

    DrawerLayout drawer;
    NavigationView navigationView;
    public static EditText txtContent;
    private EditText txtValues;
    private CheckBox checkBox;
    private Button btnSend , btnCopy;

    private ClipboardManager clipboardManager;
    private ClipData clipData;

    int value = 0;
    String content = "";
    String main_content = "";

    public static ArrayList<String> arrayList;

    private List<String> list_load;

    SharedPreferences sp;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        drawer = (DrawerLayout) findViewById(R.id.drawer);
        navigationView = (NavigationView) findViewById(R.id.nav);
        txtContent = (EditText) findViewById(R.id.txtContent);
        txtValues = (EditText) findViewById(R.id.txtValues);
        checkBox = (CheckBox) findViewById(R.id.checkBox);
        btnSend = (Button) findViewById(R.id.btnSend);
        btnCopy = (Button) findViewById(R.id.btnCopy);

        arrayList = new ArrayList<>();

        try
        {
            loadHistory();
        }
        catch (Exception e)
        {}

        clipboardManager = (ClipboardManager) getSystemService(CLIPBOARD_SERVICE);

        btnCopy.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                content = txtContent.getText().toString();
                if ( !(txtValues.getText().toString().isEmpty()) )
                {
                    value = Integer.parseInt(txtValues.getText().toString());
                }
                if (content.isEmpty())
                {
                    Toast.makeText(getBaseContext(),"متن را وارد کنید !",Toast.LENGTH_SHORT).show();
                    return;
                }
                if (value > 2000)
                {
                    Toast.makeText(getBaseContext(),"حداکثر مقدار 2000 می باشد !",Toast.LENGTH_SHORT).show();
                    return;
                }

                if (checkBox.isChecked())
                {
                    for (int i = 0 ; i < value ; i++){
                        main_content += content + "\n";
                    }
                    clipData = ClipData.newPlainText("متن" , main_content);
                    clipboardManager.setPrimaryClip(clipData);
                    Toast.makeText(getBaseContext() , "کپی شد ..." , Toast.LENGTH_SHORT).show();
                    main_content = "";
                    content = "";
                    txtContent.setText("");
                    txtValues.setText("");
                    value = 0;
                }
                else
                {
                    for (int i = 0 ; i < value ; i++){
                        main_content += content + " ";
                    }
                    clipData = ClipData.newPlainText("متن" , main_content);
                    clipboardManager.setPrimaryClip(clipData);
                    Toast.makeText(getBaseContext() , "کپی شد ..." , Toast.LENGTH_SHORT).show();
                    main_content = "";
                    content = "";
                    txtContent.setText("");
                    txtValues.setText("");
                    value = 0;
                }

            }
        });

        btnSend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                content = txtContent.getText().toString();
                if ( !(txtValues.getText().toString().isEmpty()) )
                {
                    value = Integer.parseInt(txtValues.getText().toString());
                }
                if (content.isEmpty())
                {
                    Toast.makeText(getBaseContext(),"متن را وارد کنید !",Toast.LENGTH_SHORT).show();
                    return;
                }
                if (value < 5 )
                {
                    Toast.makeText(getBaseContext(),"حداقل مقدار 5 می باشد !",Toast.LENGTH_SHORT).show();
                    return;
                }
                if (value > 2000)
                {
                    Toast.makeText(getBaseContext(),"حداکثر مقدار 2000 می باشد !",Toast.LENGTH_SHORT).show();
                    return;
                }
                if (checkBox.isChecked())
                {
                    for (int i = 0 ; i < value ; i++){
                        main_content += content + "\n";
                    }
                    arrayList.add(content);
                    saveHistory();
                    Intent i = new Intent(Intent.ACTION_SEND);
                    i.setType("text/plain");
                    i.putExtra(android.content.Intent.EXTRA_SUBJECT, "");
                    i.putExtra(android.content.Intent.EXTRA_TEXT, main_content);
                    startActivity(Intent.createChooser(i, "Share with ..."));
                    main_content = "";
                    content = "";
                    txtContent.setText("");
                    txtValues.setText("");
                    value = 0;
                }
                else
                {
                    for (int i = 0 ; i < value ; i++){
                        main_content += content + " ";
                    }
                    arrayList.add(content);
                    saveHistory();
                    Intent i = new Intent(Intent.ACTION_SEND);
                    i.setType("text/plain");
                    i.putExtra(android.content.Intent.EXTRA_SUBJECT, "");
                    i.putExtra(android.content.Intent.EXTRA_TEXT, main_content);
                    startActivity(Intent.createChooser(i, "Share with ..."));
                    main_content = "";
                    content = "";
                    txtContent.setText("");
                    txtValues.setText("");
                    value = 0;
                }

            }
        });





        navigationView.setNavigationItemSelectedListener(new NavigationView.OnNavigationItemSelectedListener() {
            @Override
            public boolean onNavigationItemSelected(@NonNull MenuItem item) {
                int id = item.getItemId();
                switch (id)
                {
                    case R.id.drawer_history:
                        startActivity(new Intent(MainActivity.this , HistoryActivity.class));
                        break;
                    case R.id.drawer_share:
                        Intent sharingIntent = new Intent(android.content.Intent.ACTION_SEND);
                        sharingIntent.setType("text/plain");
                        String shareBodyAppLinkَ = getString(R.string.download_app_link);
                        String shareSubAppLink = "";
                        sharingIntent.putExtra(android.content.Intent.EXTRA_SUBJECT, shareSubAppLink);
                        sharingIntent.putExtra(android.content.Intent.EXTRA_TEXT, shareBodyAppLinkَ);
                        startActivity(Intent.createChooser(sharingIntent, "Share with ..."));
                        break;
                    case R.id.drawer_rate_app:
                        String url= getString(R.string.url);
                        Intent intentRate = new Intent();
                        intentRate.setAction(Intent.ACTION_VIEW);
                        intentRate.setData(Uri.parse(url));
                        startActivity(intentRate);
                        break;
                    case R.id.drawer_other_apps:
                        Intent intentView = new Intent(Intent.ACTION_VIEW ,
                                Uri.parse(getString(R.string.link_other_apps)));
                        startActivity(intentView);

                        break;
                    case R.id.drawer_contact_us:
                        Intent intentContact = new Intent(android.content.Intent.ACTION_SEND);
                        intentContact.setType("message/rfc822");
                        String shareBody = "\n\n\n"+"ir.cristiansoft.spammer";
                        String shareSub = "موضوع";
                        intentContact.putExtra(Intent.EXTRA_EMAIL , new String[] {"cristiansoft7@gmail.com"});
                        intentContact.putExtra(android.content.Intent.EXTRA_SUBJECT, shareSub);
                        intentContact.putExtra(android.content.Intent.EXTRA_TEXT, shareBody);
                        startActivity(Intent.createChooser(intentContact, "Send mail ..."));
                        break;
                    case R.id.drawer_abute:
                        Dialog dialog = new Dialog(MainActivity.this);
                        dialog.setTitle("درباره");
                        dialog.setContentView(R.layout.toast_layout);
                        dialog.show();
                        break;
                    case R.id.drawer_exit:
                        exitDialog();
                        break;
                }

                drawer.closeDrawer(Gravity.RIGHT);

                return true;
            }
        });


    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.open_drawer)
        {
            if (!drawer.isDrawerOpen(Gravity.RIGHT))
            {
                drawer.openDrawer(Gravity.RIGHT);
            }
            else
            {
                drawer.closeDrawer(Gravity.RIGHT);
            }
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onBackPressed() {
        exitDialog();
    }

    private void saveHistory () {
        sp=getApplicationContext().getSharedPreferences("history", 0);
        SharedPreferences.Editor edit=sp.edit();
        edit.putString("list_history" , arrayList.toString());
        edit.apply();
        edit.commit();
    }

    private void loadHistory(){
        sp = getApplicationContext().getSharedPreferences("history" , 0);
        list_load = Arrays.asList((sp.getString("list_history" , null)).replace("[","").replace("]","").split(", "));

        for (int i=0;i<list_load.size();i++)
        {
            arrayList.add(list_load.get(i));
        }

    }

    private void exitDialog(){

        AlertDialog.Builder alertDialog=new AlertDialog.Builder(MainActivity.this);

        alertDialog.setTitle("خروج از برنامه");
        alertDialog.setMessage("از برنامه خارج شوید؟");
        alertDialog.setIcon(R.mipmap.ic_launcher);
        alertDialog.setPositiveButton("بله", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int which) {

                finish();
            }
        });

        alertDialog.setNegativeButton("امتیاز به برنامه", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
                String url= getString(R.string.url);
                Intent intentRate = new Intent();
                intentRate.setAction(Intent.ACTION_VIEW);
                intentRate.setData(Uri.parse(url));
                startActivity(intentRate);
            }
        });

        alertDialog.show();

    }


}
